import { BaseRequestAction } from '../core/action/BaseRequestAction';
import { HttpServiceHandle } from '../core/service/HttpServiceHandle';
import { Ref, UseSelector } from './types';
import { Meta, Metas, MetasLoading } from '../core/utils/types';
export declare class RequestAction<Data, A extends (...args: any[]) => HttpServiceHandle<Data, Response, Payload, M>, Response, Payload, M> extends BaseRequestAction<Data, A, Response, Payload, M> {
    protected loadingsCacheObserver?: [Metas, Ref<MetasLoading<M>>];
    useMeta<T extends keyof Meta>(key?: T): Ref<Meta> | Ref<Meta[T]>;
    useMetas<T extends keyof Meta>(value?: M, metaKey?: T): Ref<Metas<M>> | Ref<Meta[T]>;
    useLoading(): Ref<boolean>;
    useLoadings(value?: M): Ref<boolean | MetasLoading<M>>;
    protected switchReduxSelector<TState = any, TSelected = any>(): UseSelector<TState, TSelected>;
}
