"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseRequestAction_1 = require("../core/action/BaseRequestAction");
var createReduxStore_1 = require("../core/utils/createReduxStore");
var hooks_1 = require("./hooks");
var RequestAction = /** @class */ (function (_super) {
    tslib_1.__extends(RequestAction, _super);
    function RequestAction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // @ts-ignore
    RequestAction.prototype.useMeta = function (key) {
        // @ts-ignore
        return _super.prototype.useMeta.call(this, key);
    };
    // @ts-ignore
    RequestAction.prototype.useMetas = function (value, metaKey) {
        // @ts-ignore
        return _super.prototype.useMetas.call(this, value, metaKey);
    };
    // @ts-ignore
    RequestAction.prototype.useLoading = function () {
        // @ts-ignore
        return _super.prototype.useLoading.call(this);
    };
    // @ts-ignore
    RequestAction.prototype.useLoadings = function (value) {
        if (value !== undefined) {
            return this.useMetas(value, 'loading');
        }
        var metas = this.useMetas();
        if (!this.loadingsCacheObserver || this.loadingsCacheObserver[0] !== metas.value) {
            // FIXME: no observer
            this.loadingsCacheObserver = [metas.value, {
                    value: {
                        pick: function (payload) {
                            return metas.value.pick(payload).loading;
                        }
                    },
                }];
        }
        return this.loadingsCacheObserver[1];
    };
    // @ts-ignore
    RequestAction.prototype.switchReduxSelector = function () {
        return function (selector) {
            return hooks_1.computed(function () { return selector(createReduxStore_1.getStore().getState()); });
        };
    };
    return RequestAction;
}(BaseRequestAction_1.BaseRequestAction));
exports.RequestAction = RequestAction;
