"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var composition_api_1 = tslib_1.__importDefault(require("@vue/composition-api"));
var api = tslib_1.__importStar(require("@vue/composition-api"));
var isUseCompositionApi = false;
exports.observable = function (data) {
    if (isUseCompositionApi) {
        return api.reactive(data);
    }
    else {
        return vue_1.default.observable(data);
    }
};
exports.computed = function (fn) {
    if (isUseCompositionApi) {
        return api.computed(fn);
    }
    throw new ReferenceError('You are not allowed to use hooks method');
};
exports.useCompositionApi = function (autoRegisterToVue) {
    if (autoRegisterToVue === void 0) { autoRegisterToVue = false; }
    isUseCompositionApi = true;
    if (autoRegisterToVue) {
        vue_1.default.use(composition_api_1.default);
    }
};
