"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var lodash_clonedeep_1 = tslib_1.__importDefault(require("lodash.clonedeep"));
var diff_1 = require("./diff");
var createReduxStore_1 = require("../core/utils/createReduxStore");
var hooks_1 = require("./hooks");
createReduxStore_1.onStoreCreated(function (store) {
    var getCurrentState = store.getState;
    var originalState = getCurrentState();
    var observer = hooks_1.observable(lodash_clonedeep_1.default(originalState));
    store.getState = function () {
        return observer;
    };
    store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
var createReduxStore_2 = require("../core/utils/createReduxStore");
exports.createReduxStore = createReduxStore_2.createReduxStore;
